Index: XMLIO_V2/dev/dev_rv/src/xmlio/fortran/idomain.f90
===================================================================
--- XMLIO_V2/dev/dev_rv/src/xmlio/fortran/idomain.f90	(revision 270)
+++ XMLIO_V2/dev/dev_rv/src/xmlio/fortran/idomain.f90	(revision 276)
@@ -25,15 +25,15 @@
    
    SUBROUTINE set_domaingroup_attributes_id                                                                        &
-   ( domaingroup_id, name_, standard_name_, long_name_, domaingroup_group_ref_, ni_glo_, nj_glo_, ibegin_, iend_,  &
+   ( domaingroup_id, name_, standard_name_, long_name_, domain_group_ref_, ni_glo_, nj_glo_, ibegin_, iend_,       &
      ni_, jbegin_, jend_, nj_, mask_, data_dim_, data_ni_, data_nj_, data_ibegin_, data_jbegin_,                   &
      zoom_ni_, zoom_nj_, zoom_ibegin_, zoom_jbegin_, zoom_ni_loc_, zoom_nj_loc_, zoom_ibegin_loc_,                 &
      zoom_jbegin_loc_, data_n_index_, data_i_index_, data_j_index_, lonvalue_, latvalue_)
       IMPLICIT NONE
-      TYPE(XDomainGroupHandle)                                   :: domaingroup_hdl
+      TYPE(XDomainGroupHandle)                              :: domaingroup_hdl
       CHARACTER(len = *)                       , INTENT(IN) :: domaingroup_id
       CHARACTER(len = *)             , OPTIONAL, INTENT(IN) :: name_
       CHARACTER(len = *)             , OPTIONAL, INTENT(IN) :: standard_name_
       CHARACTER(len = *)             , OPTIONAL, INTENT(IN) :: long_name_
-      CHARACTER(len = *)             , OPTIONAL, INTENT(IN) :: domaingroup_group_ref_
+      CHARACTER(len = *)             , OPTIONAL, INTENT(IN) :: domain_group_ref_
       INTEGER                        , OPTIONAL, INTENT(IN) :: ni_glo_
       INTEGER                        , OPTIONAL, INTENT(IN) :: nj_glo_
@@ -66,5 +66,5 @@
       CALL domaingroup_handle_create(domaingroup_hdl, domaingroup_id)
       CALL set_domaingroup_attributes_hdl                                                                          &
-   ( domaingroup_hdl, name_, standard_name_, long_name_, domaingroup_group_ref_, ni_glo_, nj_glo_, ibegin_, iend_, &
+   ( domaingroup_hdl, name_, standard_name_, long_name_, domain_group_ref_, ni_glo_, nj_glo_, ibegin_, iend_,      &
      ni_, jbegin_, jend_, nj_, mask_, data_dim_, data_ni_, data_nj_, data_ibegin_, data_jbegin_,                   &
      zoom_ni_, zoom_nj_, zoom_ibegin_, zoom_jbegin_, zoom_ni_loc_, zoom_nj_loc_, zoom_ibegin_loc_,                 &
@@ -74,5 +74,5 @@
    
    SUBROUTINE set_domaingroup_attributes_hdl                                                                       &
-   ( domaingroup_hdl,name_, standard_name_, long_name_, domaingroup_group_ref_, ni_glo_, nj_glo_, ibegin_, iend_,  &
+   ( domaingroup_hdl,name_, standard_name_, long_name_, domain_group_ref_, ni_glo_, nj_glo_, ibegin_, iend_,       &
      ni_, jbegin_, jend_, nj_, mask_, data_dim_, data_ni_, data_nj_, data_ibegin_, data_jbegin_,                   &
      zoom_ni_, zoom_nj_, zoom_ibegin_, zoom_jbegin_, zoom_ni_loc_, zoom_nj_loc_, zoom_ibegin_loc_,                 &
@@ -83,5 +83,5 @@
       CHARACTER(len = *)               , OPTIONAL, INTENT(IN) :: standard_name_
       CHARACTER(len = *)               , OPTIONAL, INTENT(IN) :: long_name_
-      CHARACTER(len = *)               , OPTIONAL, INTENT(IN) :: domaingroup_group_ref_
+      CHARACTER(len = *)               , OPTIONAL, INTENT(IN) :: domain_group_ref_
       INTEGER                          , OPTIONAL, INTENT(IN) :: ni_glo_
       INTEGER                          , OPTIONAL, INTENT(IN) :: nj_glo_
@@ -122,6 +122,6 @@
          CALL xios_set_domaingroup_long_name(domaingroup_hdl%daddr, long_name_, len(long_name_))
        END IF
-      IF (PRESENT(domaingroup_group_ref_)) THEN
-         CALL xios_set_domaingroup_domaingroup_group_ref(domaingroup_hdl%daddr, domaingroup_group_ref_, len(domaingroup_group_ref_))
+      IF (PRESENT(domain_group_ref_)) THEN
+         CALL xios_set_domaingroup_domain_group_ref(domaingroup_hdl%daddr, domain_group_ref_, len(domain_group_ref_))
       END IF
       IF (PRESENT(ni_glo_))           THEN