Index: XMLIO_V2/dev/common/src/fortran/icdomain.cpp
===================================================================
--- XMLIO_V2/dev/common/src/fortran/icdomain.cpp	(revision 290)
+++ XMLIO_V2/dev/common/src/fortran/icdomain.cpp	(revision 300)
@@ -31,4 +31,5 @@
 
       domain_hdl->name.setValue(name_str);
+      domain_hdl->sendAttributToServer(domain_hdl->name) ; 
    }
    
@@ -39,4 +40,5 @@
 
       domain_hdl->standard_name.setValue(standard_name_str);
+      domain_hdl->sendAttributToServer(domain_hdl->standard_name) ; 
    }
    
@@ -47,4 +49,5 @@
 
       domain_hdl->long_name.setValue(long_name_str);
+      domain_hdl->sendAttributToServer(domain_hdl->long_name) ; 
    }
    
@@ -55,4 +58,5 @@
 
       domain_hdl->domain_group_ref.setValue(domain_group_ref_str);
+      domain_hdl->sendAttributToServer(domain_hdl->domain_group_ref) ; 
    }
    
@@ -60,4 +64,5 @@
    {
       domain_hdl->ni_glo.setValue(ni_glo);
+      domain_hdl->sendAttributToServer(domain_hdl->ni_glo) ; 
    }
    
@@ -65,4 +70,5 @@
    {
       domain_hdl->nj_glo.setValue(nj_glo);
+      domain_hdl->sendAttributToServer(domain_hdl->nj_glo) ; 
    }
    
@@ -70,4 +76,5 @@
    {
       domain_hdl->ibegin.setValue(ibegin);
+      domain_hdl->sendAttributToServer(domain_hdl->ibegin) ; 
    }
    
@@ -75,4 +82,5 @@
    {
       domain_hdl->iend.setValue(iend);
+      domain_hdl->sendAttributToServer(domain_hdl->iend) ; 
    }
    
@@ -80,4 +88,5 @@
    {
       domain_hdl->ni.setValue(ni);
+      domain_hdl->sendAttributToServer(domain_hdl->ni) ; 
    }
    
@@ -85,4 +94,5 @@
    {
       domain_hdl->jbegin.setValue(jbegin);
+      domain_hdl->sendAttributToServer(domain_hdl->jbegin) ; 
    }
    
@@ -90,4 +100,5 @@
    {
       domain_hdl->jend.setValue(jend);
+      domain_hdl->sendAttributToServer(domain_hdl->jend) ; 
    }
    
@@ -95,4 +106,5 @@
    {
       domain_hdl->nj.setValue(nj);
+      domain_hdl->sendAttributToServer(domain_hdl->nj) ; 
    }
    
@@ -103,4 +115,5 @@
 
       domain_hdl->mask.setValue(mask_val);
+      domain_hdl->sendAttributToServer(domain_hdl->mask) ; 
    }
    
@@ -108,4 +121,5 @@
    {
       domain_hdl->data_dim.setValue(data_dim);
+      domain_hdl->sendAttributToServer(domain_hdl->data_dim) ; 
    }
    
@@ -113,4 +127,5 @@
    {
       domain_hdl->data_ni.setValue(data_ni);
+      domain_hdl->sendAttributToServer(domain_hdl->data_ni) ; 
    }
    
@@ -118,4 +133,5 @@
    {
       domain_hdl->data_nj.setValue(data_nj);
+      domain_hdl->sendAttributToServer(domain_hdl->data_nj) ; 
    }
    
@@ -123,4 +139,5 @@
    {
       domain_hdl->data_ibegin.setValue(data_ibegin);
+      domain_hdl->sendAttributToServer(domain_hdl->data_ibegin) ; 
    }
    
@@ -128,4 +145,5 @@
    {
       domain_hdl->data_jbegin.setValue(data_jbegin);
+      domain_hdl->sendAttributToServer(domain_hdl->data_jbegin) ; 
    }
    
@@ -133,4 +151,5 @@
    {
       domain_hdl->zoom_ni.setValue(zoom_ni);
+      domain_hdl->sendAttributToServer(domain_hdl->zoom_ni) ; 
    }
    
@@ -138,4 +157,5 @@
    {
       domain_hdl->zoom_nj.setValue(zoom_nj);
+      domain_hdl->sendAttributToServer(domain_hdl->zoom_nj) ; 
    }
    
@@ -143,4 +163,5 @@
    {
       domain_hdl->zoom_ibegin.setValue(zoom_ibegin);
+      domain_hdl->sendAttributToServer(domain_hdl->zoom_ibegin) ; 
    }
     
@@ -148,4 +169,5 @@
    {
       domain_hdl->zoom_jbegin.setValue(zoom_jbegin);
+      domain_hdl->sendAttributToServer(domain_hdl->zoom_jbegin) ; 
    }
    
@@ -153,4 +175,5 @@
    {
       domain_hdl->zoom_ni_loc.setValue(zoom_ni_loc);
+      domain_hdl->sendAttributToServer(domain_hdl->zoom_ni_loc) ; 
    }
    
@@ -158,4 +181,5 @@
    {
       domain_hdl->zoom_nj_loc.setValue(zoom_nj_loc);
+      domain_hdl->sendAttributToServer(domain_hdl->zoom_nj_loc) ; 
    }
    
@@ -163,4 +187,5 @@
    {
       domain_hdl->zoom_ibegin_loc.setValue(zoom_ibegin_loc);
+      domain_hdl->sendAttributToServer(domain_hdl->zoom_ibegin_loc) ; 
    }
    
@@ -168,4 +193,5 @@
    {
       domain_hdl->zoom_jbegin_loc.setValue(zoom_jbegin_loc);
+      domain_hdl->sendAttributToServer(domain_hdl->zoom_jbegin_loc) ; 
    }
    
@@ -173,4 +199,5 @@
    {
       domain_hdl->data_n_index.setValue(data_n_index);
+      domain_hdl->sendAttributToServer(domain_hdl->data_n_index) ; 
    }
    
@@ -181,4 +208,5 @@
 
       domain_hdl->data_i_index.setValue(data_i_index_val);
+      domain_hdl->sendAttributToServer(domain_hdl->data_i_index) ; 
    }
    
@@ -189,4 +217,5 @@
 
       domain_hdl->data_j_index.setValue(data_j_index_val);
+      domain_hdl->sendAttributToServer(domain_hdl->data_j_index) ; 
    }
     
@@ -197,4 +226,5 @@
 
       domain_hdl->lonvalue.setValue(lonvalue_val);
+      domain_hdl->sendAttributToServer(domain_hdl->lonvalue) ; 
    }
    
@@ -205,7 +235,8 @@
 
       domain_hdl->latvalue.setValue(latvalue_val);
+      domain_hdl->sendAttributToServer(domain_hdl->latvalue) ; 
    }   
    
-   // -------------------- Attributs des groupes d'axes ------------------------
+   // -------------------- Attributs des groupes de domaine ------------------------
    
    
@@ -216,4 +247,6 @@
 
       domaingroup_hdl->name.setValue(name_str);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->name) ; 
+      
    }
    
@@ -224,4 +257,5 @@
 
       domaingroup_hdl->standard_name.setValue(standard_name_str);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->standard_name) ;
    }
    
@@ -232,4 +266,5 @@
 
       domaingroup_hdl->long_name.setValue(long_name_str);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->long_name) ;
    }
    
@@ -240,4 +275,5 @@
 
       domaingroup_hdl->domain_group_ref.setValue(domain_group_ref_str);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->domain_group_ref) ;
    }
    
@@ -245,4 +281,5 @@
    {
       domaingroup_hdl->ni_glo.setValue(ni_glo);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->ni_glo) ;
    }
    
@@ -250,4 +287,5 @@
    {
       domaingroup_hdl->nj_glo.setValue(nj_glo);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->nj_glo) ;
    }
    
@@ -255,4 +293,5 @@
    {
       domaingroup_hdl->ibegin.setValue(ibegin);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->ibegin) ;
    }
    
@@ -260,4 +299,5 @@
    {
       domaingroup_hdl->iend.setValue(iend);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->iend) ;
    }
    
@@ -265,4 +305,5 @@
    {
       domaingroup_hdl->ni.setValue(ni);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->ni) ;
    }
    
@@ -270,4 +311,5 @@
    {
       domaingroup_hdl->jbegin.setValue(jbegin);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->jbegin) ;
    }
    
@@ -275,4 +317,5 @@
    {
       domaingroup_hdl->jend.setValue(jend);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->jend) ;
    }
    
@@ -280,4 +323,5 @@
    {
       domaingroup_hdl->nj.setValue(nj);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->nj) ;
    }
    
@@ -288,4 +332,5 @@
 
       domaingroup_hdl->mask.setValue(mask_val);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->mask) ;
    }
    
@@ -293,4 +338,5 @@
    {
       domaingroup_hdl->data_dim.setValue(data_dim);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->data_dim) ;
    }
    
@@ -298,4 +344,5 @@
    {
       domaingroup_hdl->data_ni.setValue(data_ni);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->data_ni) ;
    }
    
@@ -303,4 +350,5 @@
    {
       domaingroup_hdl->data_nj.setValue(data_nj);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->data_nj) ;
    }
    
@@ -308,4 +356,5 @@
    {
       domaingroup_hdl->data_ibegin.setValue(data_ibegin);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->data_ibegin) ;
    }
    
@@ -313,4 +362,5 @@
    {
       domaingroup_hdl->data_jbegin.setValue(data_jbegin);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->data_jbegin) ;
    }
    
@@ -318,4 +368,5 @@
    {
       domaingroup_hdl->zoom_ni.setValue(zoom_ni);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->zoom_ni) ;
    }
    
@@ -323,4 +374,5 @@
    {
       domaingroup_hdl->zoom_nj.setValue(zoom_nj);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->zoom_nj) ;
    }
    
@@ -328,4 +380,5 @@
    {
       domaingroup_hdl->zoom_ibegin.setValue(zoom_ibegin);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->zoom_ibegin) ;
    }
     
@@ -333,4 +386,5 @@
    {
       domaingroup_hdl->zoom_jbegin.setValue(zoom_jbegin);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->zoom_jbegin) ;
    }
    
@@ -338,4 +392,5 @@
    {
       domaingroup_hdl->zoom_ni_loc.setValue(zoom_ni_loc);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->zoom_ni_loc) ;
    }
    
@@ -343,4 +398,5 @@
    {
       domaingroup_hdl->zoom_nj_loc.setValue(zoom_nj_loc);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->zoom_nj_loc) ;
    }
    
@@ -348,4 +404,5 @@
    {
       domaingroup_hdl->zoom_ibegin_loc.setValue(zoom_ibegin_loc);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->zoom_ibegin_loc) ;
    }
    
@@ -353,4 +410,5 @@
    {
       domaingroup_hdl->zoom_jbegin_loc.setValue(zoom_jbegin_loc);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->zoom_jbegin_loc) ;
    }
    
@@ -358,4 +416,5 @@
    {
       domaingroup_hdl->data_n_index.setValue(data_n_index);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->data_n_index) ;
    }
    
@@ -366,4 +425,5 @@
 
       domaingroup_hdl->data_i_index.setValue(data_i_index_val);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->data_i_index) ;
    }
    
@@ -374,4 +434,5 @@
 
       domaingroup_hdl->data_j_index.setValue(data_j_index_val);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->data_j_index) ;
    }
     
@@ -382,4 +443,5 @@
 
       domaingroup_hdl->lonvalue.setValue(lonvalue_val);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->lonvalue) ;
    }
    
@@ -390,4 +452,5 @@
 
       domaingroup_hdl->latvalue.setValue(latvalue_val);
+      domaingroup_hdl->sendAttributToServer(domaingroup_hdl->latvalue) ;
    }  
    